<template lang="pug">
.videodash.q-pa-sm
  .column
    .col.q-py-sm
      q-badge.on-left(v-if="video.error", color="red") ERROR - {{ video.error }}
      span Playing {{ name }}
    .col
      .row.items-center
        .col-auto
          .on-left {{ time(video.time) }}
        .col
          q-slider(
            :value="thetime",
            @change="updateTime",
            @pan="onPan",
            label,
            :label-value="time(video.time)",
            :min="0",
            :max="video.duration"
          )
        .col-auto
          .on-right {{ time(video.duration) }}
</template>

<script>
import last from "lodash/last";
import first from "lodash/first";

export default {
  name: "VideoDashboard",
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: true,
    },
  },
  computed: {
    name() {
      if (this.video.src) {
        return first(last(this.video.src.split("/")).split("."));
      } else {
        return "loading...";
      }
    },
    thetime() {
      if (!this.panning) return this.video.time;
      else return 0;
    },
  },
  data: () => {
    return {
      video: {},
      errors: {},
      panning: false,
    };
  },
  methods: {
    time(tim) {
      let mins = Math.floor(tim / 60);
      let secs = Math.floor(tim - mins * 60);
      return `${mins.toString().padStart(2, "0")}:${secs
        .toString()
        .padStart(2, "0")}`;
    },
    onPan(typ) {
      if (typ == "start") this.panning = true;
    },
    async updateTime(val) {
      this.panning = false;
      await this.firebase
        .ref(
          `config/${this.context.meetingid}/current/currentState/plugins/video/requestedTime`
        )
        .set(val);
    },
  },
  watch: {
    firebase: {
      immediate: true,
      handler() {
        this.$rtdbBind(
          "video",
          this.firebase.ref(
            `config/${this.context.meetingid}/current/currentState/plugins/video`
          )
        );
        // this.$rtdbBind(
        //   "errors",
        //   this.firebase.ref(
        //     `config/${this.context.meetingid}/current/currentState/errors/video`
        //   )
        // );
      },
    },
  },
};
</script>
<style lang="scss">
</style>
